/*---------------------- arraytst.cc: Array classes ------------------
  This test program illustrates the Lookout array classes,
  notably subscripting and run-time bounds checking.
  Programmer: Glenn D. Blank  
  For chapter 11 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include "\umach\cpp\libfiles\array.h"
void main()
{
  IntArray ia(10);  //construct an array of int with 10 elements
  cout << "Size of IntArray ia is " << ia.size() << endl;
  cout << "Contents of array defaults to: ";
  int i=0; //display contents of array with default values
  while (i < ia.size())
  { cout << ia[i] << ' ';
    i++;
  }
  cout << endl;
  FloatArray fa(5);  //construct an array of float with 5 elements
  i=0;  //fill an array (arbitrarily) with 6ths
  cout << "Constructing a float array, fa: ";
  while (i < fa.size())
  { fa[i] = i / 6.0;
    cout << fa[i] << ' ';  //display fa's contents as we go
    i++;
  }
  cout << endl;

  cout << "Now, a copy of float array, fa2: ";
  FloatArray fa2(fa); //copy fa2 from fa
  i=0;  //now display fa2, to show it copied
  while (i < fa2.size())
  { cout << fa2[i] << ' ' ;
    i++;
  }
  cout << endl;

  //Finally, construct a StringArray
  StringArray sa(8); //construct an array of 8 Lstrings
  sa[0] = "Glenn"; sa[1] = " David "; sa[2] = "Blank ";
  sa[3] = "Robert"; sa[4] = " F. "; sa[6] = "Barnes ";
  sa[7] = "wrote The Universal Machine";

  i=0; //display contents
  while (i < sa.length())
  { cout << i << ":" << sa[i] << " ";
    i++;
  }
  cout << endl;

  //Since an Lstring is an array of char, a StringArray is
  //a two-dimensional array.  Let's display characters.
  i=0;
  cout << "Display up to the first 5 characters of each row in sa:" << endl;
  while (i < sa.length())
  {
    cout << i << ":";
    int j=0;  //j will index the characters
    while (j < 5 && j < sa[i].length())
    { cout << sa[i][j]; //display one character
      j++;
    }
    cout << ' ';
    i++;
  }
  //Demonstrate arrays bound checking by going out of bounds
  cout << sa[7] << sa[8];
  //To get a better error message, comment out the previous
  //and see what the next line produces.
  cout << sa.sub(7) << sa.sub(8);
}

