/*--------------------------- echo.cc ---------------------------
  Read in and "echo" (display) any text file that the user chooses.
  Echos up to the first N characters--illustrates subscripting.
  Programmer: Glenn D. Blank
  For chapter 11 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <iostream.h>
#include "\umach\cpp\libfiles\file.h"

void main()
{
  //prompt user for a text file name
  Lstring filename;  //user supplied filename
  cout << "Enter the name of any text file (such as a program file):";
  cin >> filename;

  //open the file
  //open the file
  InFile in(filename);	//constructor attempts to open file
  while (!in.exists())	//user may have supplied an invalid filename
  { cout << "Cannot open file " << filename << ". Please try again:";
    cin >> filename;
    in.open(filename);	//try opening a file again
  }

  //loop through file f, echoing each line
  Lstring line(256,' '); //holds a line of input from file f
  //Echo up to the first N characters
  cout << "Echo how many characters?  Enter a number:";
  int N;     //user supplies N
  cin >> N;

  //A nested while loop
  while (!in.eof())	//outer loop reads lines from file
  { line = in.readLn();	//read a line of input
    int i=0;	//index
    while (i < N && i < line.length()) //inner loop gets characters
    //Array subscripts are covered in chapter 11
    { cout << line[i];  //output a character from line, using subscript
      i++;		//increment
    }
    cout << endl;
  }
}
