/*---------------------------- lsearch.cc -----------------------------
  Linear search finds an element matching a key,
  by going through an array one element at a time.
  Programmer: Glenn D. Blank
  For chapter 11 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
---------------------------------------------------------------------*/
#include "\umach\cpp\libfiles\array.h"
const int NotFound=-1; 	//returned if search doesn't find key

int LinearSearch(Lstring& key,StringArray& A,int lastValue)
{ int index=0; 			//index to return upon finding key
  while (index < lastValue) //still within array bounds?
  //invariant: 0 <= index < lastValue
     if (A[index] == key) return index; //found the key?
     else index = index + 1;
  return NotFound;		//never found & returned index
}

void main()	//initialize a StringArray and test LinearSearch
{ StringArray sa(10); //user-supplied list of Lstrings
  Lstring userInput;	 //a user-supplied Lstring
  int i=0;
  //Let user initialize sa
  cout << "Type in 10 strings.  Program will stop when you reach 10." << endl;
  while (i < sa.size()) //empty string?
  //invariant: 0 <= i < sa.size()
  { cout << i+1 << ":";
    sa[i] = userInput;	//insert user input into array
    i=i+1;			//variant: increment i
    cin >> userInput;	//note sentinel loop pattern
  }

  //Test LinearSearch
  cout << "Testing LinearSearch.  Press Ctrl-z then Enter to stop testing.\n";
  //Let the user supply a string to test LinearSearch
  cout << "Type in a string to test LinearSearch: ";
  cin >> userInput;
  while (!cin.eof())
  { i = LinearSearch(userInput,sa,sa.size());
    if (i == NotFound)	cout << userInput << " not found\n";
    else cout << "found " << userInput << " at index " << i << endl;
    cout << "Type in a string to test LinearSearch: ";
    cin >> userInput;
  }
  cout << "Bye!" << endl;
}
