/*-------------------- selsort.cc (Binary Search) -------------------
  A selection sort arranges elements of an array in ascending order.
  Programmer: Glenn D. Blank
  For chapter 11 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include "\umach\cpp\libfiles\array.h"

void swap(int& first,int& second) //swap first and second items
{ int temp;	//hold value for swap
  temp=first;
  first=second;
  second=temp;
}

void SelectionSort(IntArray& sortArray,int lastIndex)
{ int unsorted=0;	//first unsorted index in sortArray
  while (unsorted < lastIndex)
  //invariant: 0 <= unsorted < lastIndex
  { int lowestSoFar=unsorted; //look for lowest item index
    int index=unsorted; //reinitialize index for inner loop
    while (index <= lastIndex)
    //invariant: unsorted <= index <= lastIndex
    { if (sortArray[index] < sortArray[lowestSoFar])
		   lowestSoFar = index; //new lowest so far index
	   index = index+1;       //variant: inner loop index
	 }
	 swap(sortArray[unsorted],sortArray[lowestSoFar]);
	 unsorted = unsorted + 1; //advance to next slot
  }
}

//test by having user provide numbers in no particular order
void main()
{ IntArray sortThis(10);  //an array to be sorted
  int i=0; //counter

  cout << "Enter 10 integers in no particular order:" << endl;
  while (i < sortThis.length())
  //invariant: 0 <= i < sortThis.length()
  { cin >> sortThis[i];	//insert a user-provided integer
    i++;	//increment
  }

  //Sort all the elements (note that lastIndex==sortThis.size()-1)
  SelectionSort(sortThis,sortThis.size()-1);

  //display the results
  cout << "Here's the sorted array:";
  i=0;
  while (i < sortThis.length())
  //invariant: 0 <= i < sortThis.length()
  { cout << " " << sortThis[i];	//display value
    i++;	//increment
  }
  cout << "\nHope that looks sorted?" << endl;
}
