/*-------------------------- Celest.h --------------------------------
  class CelestialBody is a base class for class Planet and Star.
  This file shows the implementation of CelestialBody and Planet.
  Your job is to finish off the implementation of class Star.
  (Clearly this is an extreme simplification of astronomy; the idea
  is to illustrate how C++ can model a class of objects.)
  Programmer: John Chapman and Glenn D. Blank
  For chapter 14 of "The Universal Machine" (multimedia)
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <math.h>
#include <stdio.h>
#include <iostream.h>

const float Pi=3.14159;

class CelestialBody {
  public:
    CelestialBody(float rad);
    float surface_area();
    float volume();
  protected:
    CelestialBody();
    float radius;
};

//Planet derives from CelestialBody
//Planet has all the members, such as a radius,
//plus Planet has its own members, such as num_moons.
class Planet : public CelestialBody {
  public:
    Planet(float rad, int mns); 
    int get_moons();
  private:
    int num_moons;
};

//Now you declare class Star with a few members
//How is a Star different from a Planet?
//Design & implement a class Star derived from CelestialBody,
//with properties or behavior that distinguish a Star
//from a Planet or other classes derived from CelestialBody.
