/*---------------------------- NoteTest.cpp ---------------------------
  Test and demonstrate capabilities of class Note of Lookout library
  Note as in musical notes of different pitches and durations!
  The implementation details of making a computer play musical notes
    have been "hidden" in a library; you only to learn the interface,
    which is in Note.h, or program by analogy with this example.
  When compiling with Borland C++ 5.0 IDE:
  	Create a new project (File, New, Project) called libtest.
	Use Target Expert to set project with these settings:
	DOS STANDARD platform, LARGE target model, BGI on.
	Add LOOKOUT.LIB to your project (using the Insert key).
  The multimedia explains this procedure in detail: in "UM",
	click on the Find button and look for "Lookout library".
  Programmer: Glenn D. Blank and Jesse Thilo
  For chapter 5 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <iostream.h>
#include "\umach\cpp\libfiles\note.h"
//header file for Lookout's Note class

void main()
{
  //First, construct some notes
   Note C("C"), D("D"), E("E"), F("F"), G("G"), A("A"), B("B"); //white keys
  //The following two lines define identical sets of notes (sharps and flats).
  //Only the names have been changed to protect the innocent
  Note Csharp("C+"),Dsharp("D+"),Fsharp("F+"),Gsharp("G+"),Asharp("A+"),
    Dflat("D-"),Eflat("E-"),Gflat("G-"),Aflat("A-"),Bflat("B-"); //black keys
  //A "rest" is a Note that plays silence (for some duration)
  Note Rest(" "); //Space denotes a rest

 //Play a twelve-tone scale -- first up
  C.show(); C.quarter(); C.play();
  Csharp.show(); Csharp.quarter(); Csharp.play();
  D.show(); D.quarter(); D.play();
  Dsharp.show(); Dsharp.quarter(); Dsharp.play();
  E.show(); E.quarter(); E.play();
  F.show(); F.quarter(); F.play();
  Fsharp.show(); Fsharp.quarter(); Fsharp.play();
  G.show(); G.quarter(); G.play();
  Gsharp.show(); Gsharp.quarter(); Gsharp.play();
  A.show(); A.quarter(); A.play();
  Asharp.show(); Asharp.quarter(); Asharp.play();
  B.show(); B.quarter(); B.play();
  C.show(); C.setOctave(5); //middle C is octave 4
  C.half(); C.play();
  cout << endl;

  Rest.show(); Rest.whole(); Rest.play();  //Rest between tunes

  Rest.eighth();
 //Play part of a tune, while displaying notes on the screen
  C.setOctave(4);	//back to middle C
  C.show(); C.quarter(); C.play();  Rest.play();
  C.show(); C.quarter(); C.play();  Rest.play();
  G.show(); G.quarter(); G.play();  Rest.play();
  G.show(); G.quarter(); G.play();  Rest.play();
  A.show(); A.quarter(); A.play();  Rest.play();
  A.show(); A.quarter(); A.play();  Rest.play();
  G.show(); G.half(); G.play();	  Rest.play();
  F.show(); F.quarter(); F.play();  Rest.play();
  F.show(); F.quarter(); F.play();  Rest.play();
  E.show(); E.quarter(); E.play();  Rest.play();
  E.show(); E.quarter(); E.play();  Rest.play();
  D.show(); D.quarter(); D.play();  Rest.play();
  D.show(); D.quarter(); D.play();  Rest.play();
  C.show(); C.half(); C.play();
  cout << endl;
}
