/*--------------- shapmenu.cc: A shapes drawing program ---------------
  Lets user select a shape, determine its size, then draw it on screen.
  Illustrates use of a multi-branching if statement
     as well as shape classes from Lookout library.
  Shape classes represents and draws geometric shapes on a DOS screen.
  For details about shapes, see shaptest.cc.
  Programmer: Glenn D. Blank
  Note: in LOOKOUT, compile with F5, not F4.
  For chapter 7 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
---------------------------------------------------------------------*/
#include "\umach\cpp\libfiles\shapes.h"
//header file for Lookout's shape classes
#include <iostream.h>

void main()
{
  char choice;	//User's menu choice
  //give user a menu of possible shapes
  cout << "----- Megabyte Company drawing program -----" << endl;
  cout << "Draw a Circle, Triangle or Rectangle? Choose C,T,R:";
  cin >> choice;

  const int centerX=320;	//center of screen, 640 pixels wide
  const int centerY=240;	//center of screen, 480 pixels high

  //if circle then get its radius & draw it (center screen)
  if (choice == 'c' || choice == 'C')
  { cout << "Please enter the radius, in inches:";
    float radius;	//user supplies radius
    cin >> radius;
    Circle aCircle = Circle(radius,centerX,centerY); //construct
    aCircle.draw();	//draw it
    cin.get(); cin.get(); //first eat Enter key, two to switch back to text mode
  }
  //if triangle then get (equilateral) side and draw it
  else if (choice == 't' || choice == 'T')
  { cout << "Please enter the length of a side, in inches:";
    float side;	//user supplies one side of an equilateral triangle
    cin >> side;
    Triangle aTriangle = Triangle(side,centerX,centerY); 
    aTriangle.draw();	//draw it
    cin.get(); cin.get(); //first eat Enter key, two to switch back
  } 
  //if rectangle then get its height and width and draw it   
  else if (choice == 'r' || choice == 'R')
  { cout << "Please enter the height and width, in inches:";
    float height,width; //user supplies three sides
    cin >> height >> width;
    Rectangle aRect = Rectangle(height,width,centerX,centerY);
    aRect.draw();	//draw it
    cin.get(); cin.get(); //first eat Enter key, two to switch back
  } 
  //else point out error in user choice
  else cout << endl << choice
	    << " is not a valid letter choice." << endl;
}
